#include <avr/io.h>
#include <util/delay.h>

//включить все светодиоды
void full_leds_on()
{
		PORTD |= _BV(PD4);
		PORTB |= _BV(PB6);
		PORTD |= _BV(PD3);		
		PORTB |= _BV(PB7);
		PORTD |= _BV(PD2);
		PORTD |= _BV(PD5);
		PORTD |= _BV(PD1);
		PORTD |= _BV(PD6);
		PORTD |= _BV(PD0);
		PORTD |= _BV(PD7);
		PORTC |= _BV(PC5);
		PORTB |= _BV(PB0);
		PORTC |= _BV(PC4);
		PORTB |= _BV(PB1);
		PORTC |= _BV(PC3);
		PORTB |= _BV(PB2);
		PORTC |= _BV(PC2);
		PORTB |= _BV(PB3);
		PORTC |= _BV(PC1);
		PORTB |= _BV(PB4);
		PORTC |= _BV(PC0);
		PORTB |= _BV(PB5);
}

//выключить все светодиоды
void full_leds_off()
{
		PORTD &= ~_BV(PD4);
		PORTB &= ~_BV(PB6);
		PORTD &= ~_BV(PD3);
		PORTB &= ~_BV(PB7);
		PORTD &= ~_BV(PD2);
		PORTD &= ~_BV(PD5);
		PORTD &= ~_BV(PD1);
		PORTD &= ~_BV(PD6);
		PORTD &= ~_BV(PD0);
		PORTD &= ~_BV(PD7);
		PORTC &= ~_BV(PC5);
		PORTB &= ~_BV(PB0);
		PORTC &= ~_BV(PC4);
		PORTB &= ~_BV(PB1);
		PORTC &= ~_BV(PC3);
		PORTB &= ~_BV(PB2);
		PORTC &= ~_BV(PC2);
		PORTB &= ~_BV(PB3);
		PORTC &= ~_BV(PC1);
		PORTB &= ~_BV(PB4);
		PORTC &= ~_BV(PC0);
		PORTB &= ~_BV(PB5);
}

//равномерное заполнение от верха к низу
void heart_one()
{
		PORTD |= _BV(PD4);
		PORTB |= _BV(PB6);
		_delay_ms(50);
		PORTD |= _BV(PD3);		
		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTD |= _BV(PD2);
		PORTD |= _BV(PD5);
		_delay_ms(50);
		PORTD |= _BV(PD1);
		PORTD |= _BV(PD6);
		_delay_ms(50);
		PORTD |= _BV(PD0);
		PORTD |= _BV(PD7);
		_delay_ms(50);
		PORTC |= _BV(PC5);
		PORTB |= _BV(PB0);
		_delay_ms(50);
		PORTC |= _BV(PC4);
		PORTB |= _BV(PB1);
		_delay_ms(50);
		PORTC |= _BV(PC3);
		PORTB |= _BV(PB2);
		_delay_ms(50);
		PORTC |= _BV(PC2);
		PORTB |= _BV(PB3);
		_delay_ms(50);
		PORTC |= _BV(PC1);
		PORTB |= _BV(PB4);
		_delay_ms(50);
		PORTC |= _BV(PC0);
		PORTB |= _BV(PB5);
}

//равномерное заполнение от низа к верху
void heart_two()
{
		PORTC |= _BV(PC0);
		_delay_ms(50);
		PORTC |= _BV(PC1);
		PORTB |= _BV(PB5);
		_delay_ms(50);
		PORTC |= _BV(PC2);
		PORTB |= _BV(PB4);
		_delay_ms(50);
		PORTC |= _BV(PC3);
		PORTB |= _BV(PB3);
		_delay_ms(50);
		PORTC |= _BV(PC4);
		PORTB |= _BV(PB2);
		_delay_ms(50);
		PORTC |= _BV(PC5);
		PORTB |= _BV(PB1);
		_delay_ms(50);
		PORTD |= _BV(PD0);
		PORTB |= _BV(PB0);
		_delay_ms(50);
		PORTD |= _BV(PD1);
		PORTD |= _BV(PD7);
		_delay_ms(50);
		PORTD |= _BV(PD2);
		PORTD |= _BV(PD6);
		_delay_ms(50);
		PORTD |= _BV(PD3);
		PORTD |= _BV(PD5);
		_delay_ms(50);
		PORTD |= _BV(PD4);
		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTB |= _BV(PB6);
		_delay_ms(50);	
}

//бегущий огонь по кругу по часовой стрелке
void heart_three()
{
		PORTD |= _BV(PD4);
		_delay_ms(50);
		PORTD &= ~_BV(PD4);
		_delay_ms(50);
		
		PORTD |= _BV(PD3);
		_delay_ms(50);
		PORTD &= ~_BV(PD3);
		_delay_ms(50);

		PORTD |= _BV(PD2);
		_delay_ms(50);
		PORTD &= ~_BV(PD2);
		_delay_ms(50);

		PORTD |= _BV(PD1);
		_delay_ms(50);
		PORTD &= ~_BV(PD1);
		_delay_ms(50);

		PORTD |= _BV(PD0);
		_delay_ms(50);
		PORTD &= ~_BV(PD0);
		_delay_ms(50);

		PORTC |= _BV(PC5);
		_delay_ms(50);
		PORTC &= ~_BV(PC5);
		_delay_ms(50);

		PORTC |= _BV(PC4);
		_delay_ms(50);
		PORTC &= ~_BV(PC4);
		_delay_ms(50);

		PORTC |= _BV(PC3);
		_delay_ms(50);
		PORTC &= ~_BV(PC3);
		_delay_ms(50);

		PORTC |= _BV(PC2);
		_delay_ms(50);
		PORTC &= ~_BV(PC2);
		_delay_ms(50);

		PORTC |= _BV(PC1);
		_delay_ms(50);
		PORTC &= ~_BV(PC1);
		_delay_ms(50);

		PORTC |= _BV(PC0);
		_delay_ms(50);
		PORTC &= ~_BV(PC0);
		_delay_ms(50);

		PORTB |= _BV(PB5);
		_delay_ms(50);
		PORTB &= ~_BV(PB5);
		_delay_ms(50);

		PORTB |= _BV(PB4);
		_delay_ms(50);
		PORTB &= ~_BV(PB4);
		_delay_ms(50);

		PORTB |= _BV(PB3);
		_delay_ms(50);
		PORTB &= ~_BV(PB3);
		_delay_ms(50);

		PORTB |= _BV(PB2);
		_delay_ms(50);
		PORTB &= ~_BV(PB2);
		_delay_ms(50);

		PORTB |= _BV(PB1);
		_delay_ms(50);
		PORTB &= ~_BV(PB1);
		_delay_ms(50);

		PORTB |= _BV(PB0);
		_delay_ms(50);
		PORTB &= ~_BV(PB0);
		_delay_ms(50);

		PORTD |= _BV(PD7);
		_delay_ms(50);
		PORTD &= ~_BV(PD7);
		_delay_ms(50);

		PORTD |= _BV(PD6);
		_delay_ms(50);
		PORTD &= ~_BV(PD6);
		_delay_ms(50);

		PORTD |= _BV(PD5);
		_delay_ms(50);
		PORTD &= ~_BV(PD5);
		_delay_ms(50);

		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTB &= ~_BV(PB7);
		_delay_ms(50);

		PORTB |= _BV(PB6);
		_delay_ms(50);
		PORTB &= ~_BV(PB6);
		_delay_ms(50);		
}

//бегущий огонь по кругу поротив часовой стрелки
void heart_four()
{
		PORTB |= _BV(PB6);
		_delay_ms(50);
		PORTB &= ~_BV(PB6);
		_delay_ms(50);

		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTB &= ~_BV(PB7);
		_delay_ms(50);

		PORTD |= _BV(PD5);
		_delay_ms(50);
		PORTD &= ~_BV(PD5);
		_delay_ms(50);

		PORTD |= _BV(PD6);
		_delay_ms(50);
		PORTD &= ~_BV(PD6);
		_delay_ms(50);

		PORTD |= _BV(PD7);
		_delay_ms(50);
		PORTD &= ~_BV(PD7);
		_delay_ms(50);

		PORTB |= _BV(PB0);
		_delay_ms(50);
		PORTB &= ~_BV(PB0);
		_delay_ms(50);

		PORTB |= _BV(PB1);
		_delay_ms(50);
		PORTB &= ~_BV(PB1);
		_delay_ms(50);

		PORTB |= _BV(PB2);
		_delay_ms(50);
		PORTB &= ~_BV(PB2);
		_delay_ms(50);

		PORTB |= _BV(PB3);
		_delay_ms(50);
		PORTB &= ~_BV(PB3);
		_delay_ms(50);

		PORTB |= _BV(PB4);
		_delay_ms(50);
		PORTB &= ~_BV(PB4);
		_delay_ms(50);

		PORTB |= _BV(PB5);
		_delay_ms(50);
		PORTB &= ~_BV(PB5);
		_delay_ms(50);

		PORTC |= _BV(PC0);
		_delay_ms(50);
		PORTC &= ~_BV(PC0);
		_delay_ms(50);

		PORTC |= _BV(PC1);
		_delay_ms(50);
		PORTC &= ~_BV(PC1);
		_delay_ms(50);

		PORTC |= _BV(PC2);
		_delay_ms(50);
		PORTC &= ~_BV(PC2);
		_delay_ms(50);

		PORTC |= _BV(PC3);
		_delay_ms(50);
		PORTC &= ~_BV(PC3);
		_delay_ms(50);

		PORTC |= _BV(PC4);
		_delay_ms(50);
		PORTC &= ~_BV(PC4);
		_delay_ms(50);

		PORTC |= _BV(PC5);
		_delay_ms(50);
		PORTC &= ~_BV(PC5);
		_delay_ms(50);

		PORTD |= _BV(PD0);
		_delay_ms(50);
		PORTD &= ~_BV(PD0);
		_delay_ms(50);

		PORTD |= _BV(PD1);
		_delay_ms(50);
		PORTD &= ~_BV(PD1);
		_delay_ms(50);

		PORTD |= _BV(PD2);
		_delay_ms(50);
		PORTD &= ~_BV(PD2);
		_delay_ms(50);

		PORTD |= _BV(PD3);
		_delay_ms(50);
		PORTD &= ~_BV(PD3);
		_delay_ms(50);

		PORTD |= _BV(PD4);
		_delay_ms(50);
		PORTD &= ~_BV(PD4);
		_delay_ms(50);
}

//бегуший огонь с заполнением по часовой стрелке
void heart_five()
{
		PORTB |= _BV(PB6);
		_delay_ms(50);

		PORTD |= _BV(PD4);
		_delay_ms(50);
		
		PORTD |= _BV(PD3);
		_delay_ms(50);

		PORTD |= _BV(PD2);
		_delay_ms(50);

		PORTD |= _BV(PD1);
		_delay_ms(50);

		PORTD |= _BV(PD0);
		_delay_ms(50);

		PORTC |= _BV(PC5);
		_delay_ms(50);

		PORTC |= _BV(PC4);
		_delay_ms(50);

		PORTC |= _BV(PC3);
		_delay_ms(50);

		PORTC |= _BV(PC2);
		_delay_ms(50);

		PORTC |= _BV(PC1);
		_delay_ms(50);

		PORTC |= _BV(PC0);
		_delay_ms(50);

		PORTB |= _BV(PB5);
		_delay_ms(50);

		PORTB |= _BV(PB4);
		_delay_ms(50);

		PORTB |= _BV(PB3);
		_delay_ms(50);

		PORTB |= _BV(PB2);
		_delay_ms(50);

		PORTB |= _BV(PB1);
		_delay_ms(50);

		PORTB |= _BV(PB0);
		_delay_ms(50);

		PORTD |= _BV(PD7);
		_delay_ms(50);

		PORTD |= _BV(PD6);
		_delay_ms(50);

		PORTD |= _BV(PD5);
		_delay_ms(50);

		PORTB |= _BV(PB7);
		_delay_ms(50);
}

//бегуший огонь с заполнением против часовой стрелки
void heart_six()
{
		PORTB |= _BV(PB6);
		_delay_ms(50);

		PORTB |= _BV(PB7);
		_delay_ms(50);

		PORTD |= _BV(PD5);
		_delay_ms(50);

		PORTD |= _BV(PD6);
		_delay_ms(50);

		PORTD |= _BV(PD7);
		_delay_ms(50);

		PORTB |= _BV(PB0);
		_delay_ms(50);

		PORTB |= _BV(PB1);
		_delay_ms(50);

		PORTB |= _BV(PB2);
		_delay_ms(50);

		PORTB |= _BV(PB3);
		_delay_ms(50);

		PORTB |= _BV(PB4);
		_delay_ms(50);

		PORTB |= _BV(PB5);
		_delay_ms(50);

		PORTC |= _BV(PC0);
		_delay_ms(50);

		PORTC |= _BV(PC1);
		_delay_ms(50);

		PORTC |= _BV(PC2);
		_delay_ms(50);

		PORTC |= _BV(PC3);
		_delay_ms(50);

		PORTC |= _BV(PC4);
		_delay_ms(50);

		PORTC |= _BV(PC5);
		_delay_ms(50);

		PORTD |= _BV(PD0);
		_delay_ms(50);

		PORTD |= _BV(PD1);
		_delay_ms(50);

		PORTD |= _BV(PD2);
		_delay_ms(50);

		PORTD |= _BV(PD3);
		_delay_ms(50);

		PORTD |= _BV(PD4);
		_delay_ms(50);

		PORTB |= _BV(PB6);
		_delay_ms(50);
}

//половинки сердца мигающие поочередно
void heart_seven()
{
		PORTB |= _BV(PB6);
		PORTD |= _BV(PD4);
		PORTD |= _BV(PD3);
		PORTD |= _BV(PD2);
		PORTD |= _BV(PD1);
		PORTD |= _BV(PD0);
		PORTC |= _BV(PC5);
		PORTC |= _BV(PC4);
		PORTC |= _BV(PC3);
		PORTC |= _BV(PC2);
		PORTC |= _BV(PC1);
		PORTC |= _BV(PC0);
		_delay_ms(1000);
		full_leds_off();
		PORTC |= _BV(PC0);
		PORTB |= _BV(PB5);
		PORTB |= _BV(PB4);
		PORTB |= _BV(PB3);
		PORTB |= _BV(PB2);
		PORTB |= _BV(PB1);
		PORTB |= _BV(PB0);
		PORTD |= _BV(PD7);
		PORTD |= _BV(PD6);
		PORTD |= _BV(PD5);
		PORTB |= _BV(PB7);
		PORTB |= _BV(PB6);
		_delay_ms(1000);
		full_leds_off();
		PORTB |= _BV(PB6);
		PORTD |= _BV(PD4);
		PORTD |= _BV(PD3);
		PORTD |= _BV(PD2);
		PORTD |= _BV(PD1);
		PORTD |= _BV(PD0);
		PORTC |= _BV(PC5);
		PORTC |= _BV(PC4);
		PORTC |= _BV(PC3);
		PORTC |= _BV(PC2);
		PORTC |= _BV(PC1);
		PORTC |= _BV(PC0);
		_delay_ms(1000);
		full_leds_off();
		PORTC |= _BV(PC0);
		PORTB |= _BV(PB5);
		PORTB |= _BV(PB4);
		PORTB |= _BV(PB3);
		PORTB |= _BV(PB2);
		PORTB |= _BV(PB1);
		PORTB |= _BV(PB0);
		PORTD |= _BV(PD7);
		PORTD |= _BV(PD6);
		PORTD |= _BV(PD5);
		PORTB |= _BV(PB7);
		PORTB |= _BV(PB6);
}

void heart_eight()
{
		//центральный - верх*******	
		PORTB |= _BV(PB6);
		_delay_ms(50);
		PORTB &= ~_BV(PB6);
		_delay_ms(50);
		//*************************

		PORTD |= _BV(PD4);
		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTD &= ~_BV(PD4);
		PORTB &= ~_BV(PB7);
		_delay_ms(50);
		
		PORTD |= _BV(PD3);
		PORTD |= _BV(PD5);
		_delay_ms(50);
		PORTD &= ~_BV(PD3);
		PORTD &= ~_BV(PD5);
		_delay_ms(50);

		PORTD |= _BV(PD2);
		PORTD |= _BV(PD6);
		_delay_ms(50);
		PORTD &= ~_BV(PD2);
		PORTD &= ~_BV(PD6);
		_delay_ms(50);

		PORTD |= _BV(PD1);
		PORTD |= _BV(PD7);
		_delay_ms(50);
		PORTD &= ~_BV(PD1);
		PORTD &= ~_BV(PD7);
		_delay_ms(50);

		PORTD |= _BV(PD0);
		PORTB |= _BV(PB0);
		_delay_ms(50);
		PORTD &= ~_BV(PD0);
		PORTB &= ~_BV(PB0);
		_delay_ms(50);

		PORTC |= _BV(PC5);
		PORTB |= _BV(PB1);
		_delay_ms(50);
		PORTC &= ~_BV(PC5);
		PORTB &= ~_BV(PB1);
		_delay_ms(50);

		PORTC |= _BV(PC4);
		PORTB |= _BV(PB2);
		_delay_ms(50);
		PORTC &= ~_BV(PC4);
		PORTB &= ~_BV(PB2);
		_delay_ms(50);

		PORTC |= _BV(PC3);
		PORTB |= _BV(PB3);
		_delay_ms(50);
		PORTC &= ~_BV(PC3);
		PORTB &= ~_BV(PB3);
		_delay_ms(50);

		PORTC |= _BV(PC2);
		PORTB |= _BV(PB4);
		_delay_ms(50);
		PORTC &= ~_BV(PC2);
		PORTB &= ~_BV(PB4);
		_delay_ms(50);

		PORTC |= _BV(PC1);
		PORTB |= _BV(PB5);
		_delay_ms(50);
		PORTC &= ~_BV(PC1);
		PORTB &= ~_BV(PB5);
		_delay_ms(50);

		//центр - низ**************
		PORTC |= _BV(PC0);
		_delay_ms(50);
		//*************************

		PORTD |= _BV(PD4);
		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTD &= ~_BV(PD4);
		PORTB &= ~_BV(PB7);
		_delay_ms(50);
		
		PORTD |= _BV(PD3);
		PORTD |= _BV(PD5);
		_delay_ms(50);
		PORTD &= ~_BV(PD3);
		PORTD &= ~_BV(PD5);
		_delay_ms(50);

		PORTD |= _BV(PD2);
		PORTD |= _BV(PD6);
		_delay_ms(50);
		PORTD &= ~_BV(PD2);
		PORTD &= ~_BV(PD6);
		_delay_ms(50);

		PORTD |= _BV(PD1);
		PORTD |= _BV(PD7);
		_delay_ms(50);
		PORTD &= ~_BV(PD1);
		PORTD &= ~_BV(PD7);
		_delay_ms(50);

		PORTD |= _BV(PD0);
		PORTB |= _BV(PB0);
		_delay_ms(50);
		PORTD &= ~_BV(PD0);
		PORTB &= ~_BV(PB0);
		_delay_ms(50);

		PORTC |= _BV(PC5);
		PORTB |= _BV(PB1);
		_delay_ms(50);
		PORTC &= ~_BV(PC5);
		PORTB &= ~_BV(PB1);
		_delay_ms(50);

		PORTC |= _BV(PC4);
		PORTB |= _BV(PB2);
		_delay_ms(50);
		PORTC &= ~_BV(PC4);
		PORTB &= ~_BV(PB2);
		_delay_ms(50);

		PORTC |= _BV(PC3);
		PORTB |= _BV(PB3);
		_delay_ms(50);
		PORTC &= ~_BV(PC3);
		PORTB &= ~_BV(PB3);
		_delay_ms(50);

		PORTC |= _BV(PC2);
		PORTB |= _BV(PB4);
		_delay_ms(50);
		PORTC &= ~_BV(PC2);
		PORTB &= ~_BV(PB4);
		_delay_ms(50);

		PORTC |= _BV(PC1);
		PORTB |= _BV(PB5);
		_delay_ms(50);
		//-- 
		PORTB |= _BV(PB6);
		_delay_ms(50);
		PORTB &= ~_BV(PB6);
		_delay_ms(50);

		PORTD |= _BV(PD4);
		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTD &= ~_BV(PD4);
		PORTB &= ~_BV(PB7);
		_delay_ms(50);
		
		PORTD |= _BV(PD3);
		PORTD |= _BV(PD5);
		_delay_ms(50);
		PORTD &= ~_BV(PD3);
		PORTD &= ~_BV(PD5);
		_delay_ms(50);

		PORTD |= _BV(PD2);
		PORTD |= _BV(PD6);
		_delay_ms(50);
		PORTD &= ~_BV(PD2);
		PORTD &= ~_BV(PD6);
		_delay_ms(50);

		PORTD |= _BV(PD1);
		PORTD |= _BV(PD7);
		_delay_ms(50);
		PORTD &= ~_BV(PD1);
		PORTD &= ~_BV(PD7);
		_delay_ms(50);

		PORTD |= _BV(PD0);
		PORTB |= _BV(PB0);
		_delay_ms(50);
		PORTD &= ~_BV(PD0);
		PORTB &= ~_BV(PB0);
		_delay_ms(50);

		PORTC |= _BV(PC5);
		PORTB |= _BV(PB1);
		_delay_ms(50);
		PORTC &= ~_BV(PC5);
		PORTB &= ~_BV(PB1);
		_delay_ms(50);

		PORTC |= _BV(PC4);
		PORTB |= _BV(PB2);
		_delay_ms(50);
		PORTC &= ~_BV(PC4);
		PORTB &= ~_BV(PB2);
		_delay_ms(50);

		PORTC |= _BV(PC3);
		PORTB |= _BV(PB3);
		_delay_ms(50);
		PORTC &= ~_BV(PC3);
		PORTB &= ~_BV(PB3);
		_delay_ms(50);

		PORTC |= _BV(PC2);
		PORTB |= _BV(PB4);
		_delay_ms(50);
		//--
		PORTB |= _BV(PB6);
		_delay_ms(50);
		PORTB &= ~_BV(PB6);
		_delay_ms(50);

		PORTD |= _BV(PD4);
		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTD &= ~_BV(PD4);
		PORTB &= ~_BV(PB7);
		_delay_ms(50);
		
		PORTD |= _BV(PD3);
		PORTD |= _BV(PD5);
		_delay_ms(50);
		PORTD &= ~_BV(PD3);
		PORTD &= ~_BV(PD5);
		_delay_ms(50);

		PORTD |= _BV(PD2);
		PORTD |= _BV(PD6);
		_delay_ms(50);
		PORTD &= ~_BV(PD2);
		PORTD &= ~_BV(PD6);
		_delay_ms(50);

		PORTD |= _BV(PD1);
		PORTD |= _BV(PD7);
		_delay_ms(50);
		PORTD &= ~_BV(PD1);
		PORTD &= ~_BV(PD7);
		_delay_ms(50);

		PORTD |= _BV(PD0);
		PORTB |= _BV(PB0);
		_delay_ms(50);
		PORTD &= ~_BV(PD0);
		PORTB &= ~_BV(PB0);
		_delay_ms(50);

		PORTC |= _BV(PC5);
		PORTB |= _BV(PB1);
		_delay_ms(50);
		PORTC &= ~_BV(PC5);
		PORTB &= ~_BV(PB1);
		_delay_ms(50);

		PORTC |= _BV(PC4);
		PORTB |= _BV(PB2);
		_delay_ms(50);
		PORTC &= ~_BV(PC4);
		PORTB &= ~_BV(PB2);
		_delay_ms(50);

		PORTC |= _BV(PC3);
		PORTB |= _BV(PB3);
		_delay_ms(50);
		//--
		PORTB |= _BV(PB6);
		_delay_ms(50);
		PORTB &= ~_BV(PB6);
		_delay_ms(50);

		PORTD |= _BV(PD4);
		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTD &= ~_BV(PD4);
		PORTB &= ~_BV(PB7);
		_delay_ms(50);
		
		PORTD |= _BV(PD3);
		PORTD |= _BV(PD5);
		_delay_ms(50);
		PORTD &= ~_BV(PD3);
		PORTD &= ~_BV(PD5);
		_delay_ms(50);

		PORTD |= _BV(PD2);
		PORTD |= _BV(PD6);
		_delay_ms(50);
		PORTD &= ~_BV(PD2);
		PORTD &= ~_BV(PD6);
		_delay_ms(50);

		PORTD |= _BV(PD1);
		PORTD |= _BV(PD7);
		_delay_ms(50);
		PORTD &= ~_BV(PD1);
		PORTD &= ~_BV(PD7);
		_delay_ms(50);

		PORTD |= _BV(PD0);
		PORTB |= _BV(PB0);
		_delay_ms(50);
		PORTD &= ~_BV(PD0);
		PORTB &= ~_BV(PB0);
		_delay_ms(50);

		PORTC |= _BV(PC5);
		PORTB |= _BV(PB1);
		_delay_ms(50);
		PORTC &= ~_BV(PC5);
		PORTB &= ~_BV(PB1);
		_delay_ms(50);

		PORTC |= _BV(PC4);
		PORTB |= _BV(PB2);
		_delay_ms(50);
		//--
		PORTB |= _BV(PB6);
		_delay_ms(50);
		PORTB &= ~_BV(PB6);
		_delay_ms(50);

		PORTD |= _BV(PD4);
		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTD &= ~_BV(PD4);
		PORTB &= ~_BV(PB7);
		_delay_ms(50);
		
		PORTD |= _BV(PD3);
		PORTD |= _BV(PD5);
		_delay_ms(50);
		PORTD &= ~_BV(PD3);
		PORTD &= ~_BV(PD5);
		_delay_ms(50);

		PORTD |= _BV(PD2);
		PORTD |= _BV(PD6);
		_delay_ms(50);
		PORTD &= ~_BV(PD2);
		PORTD &= ~_BV(PD6);
		_delay_ms(50);

		PORTD |= _BV(PD1);
		PORTD |= _BV(PD7);
		_delay_ms(50);
		PORTD &= ~_BV(PD1);
		PORTD &= ~_BV(PD7);
		_delay_ms(50);

		PORTD |= _BV(PD0);
		PORTB |= _BV(PB0);
		_delay_ms(50);
		PORTD &= ~_BV(PD0);
		PORTB &= ~_BV(PB0);
		_delay_ms(50);

		PORTC |= _BV(PC5);
		PORTB |= _BV(PB1);
		_delay_ms(50);
		//--
		PORTB |= _BV(PB6);
		_delay_ms(50);
		PORTB &= ~_BV(PB6);
		_delay_ms(50);

		PORTD |= _BV(PD4);
		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTD &= ~_BV(PD4);
		PORTB &= ~_BV(PB7);
		_delay_ms(50);
		
		PORTD |= _BV(PD3);
		PORTD |= _BV(PD5);
		_delay_ms(50);
		PORTD &= ~_BV(PD3);
		PORTD &= ~_BV(PD5);
		_delay_ms(50);

		PORTD |= _BV(PD2);
		PORTD |= _BV(PD6);
		_delay_ms(50);
		PORTD &= ~_BV(PD2);
		PORTD &= ~_BV(PD6);
		_delay_ms(50);

		PORTD |= _BV(PD1);
		PORTD |= _BV(PD7);
		_delay_ms(50);
		PORTD &= ~_BV(PD1);
		PORTD &= ~_BV(PD7);
		_delay_ms(50);

		PORTD |= _BV(PD0);
		PORTB |= _BV(PB0);
		_delay_ms(50);
		//--
		PORTB |= _BV(PB6);
		_delay_ms(50);
		PORTB &= ~_BV(PB6);
		_delay_ms(50);

		PORTD |= _BV(PD4);
		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTD &= ~_BV(PD4);
		PORTB &= ~_BV(PB7);
		_delay_ms(50);
		
		PORTD |= _BV(PD3);
		PORTD |= _BV(PD5);
		_delay_ms(50);
		PORTD &= ~_BV(PD3);
		PORTD &= ~_BV(PD5);
		_delay_ms(50);

		PORTD |= _BV(PD2);
		PORTD |= _BV(PD6);
		_delay_ms(50);
		PORTD &= ~_BV(PD2);
		PORTD &= ~_BV(PD6);
		_delay_ms(50);

		PORTD |= _BV(PD1);
		PORTD |= _BV(PD7);
		_delay_ms(50);
		//--
		PORTB |= _BV(PB6);
		_delay_ms(50);
		PORTB &= ~_BV(PB6);
		_delay_ms(50);

		PORTD |= _BV(PD4);
		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTD &= ~_BV(PD4);
		PORTB &= ~_BV(PB7);
		_delay_ms(50);
		
		PORTD |= _BV(PD3);
		PORTD |= _BV(PD5);
		_delay_ms(50);
		PORTD &= ~_BV(PD3);
		PORTD &= ~_BV(PD5);
		_delay_ms(50);

		PORTD |= _BV(PD2);
		PORTD |= _BV(PD6);
		_delay_ms(50);
		//--
		PORTB |= _BV(PB6);
		_delay_ms(50);
		PORTB &= ~_BV(PB6);
		_delay_ms(50);

		PORTD |= _BV(PD4);
		PORTB |= _BV(PB7);
		_delay_ms(50);
		PORTD &= ~_BV(PD4);
		PORTB &= ~_BV(PB7);
		_delay_ms(50);
		
		PORTD |= _BV(PD3);
		PORTD |= _BV(PD5);
		_delay_ms(50);
		//--
		PORTB |= _BV(PB6);
		_delay_ms(50);
		PORTB &= ~_BV(PB6);
		_delay_ms(50);

		PORTD |= _BV(PD4);
		PORTB |= _BV(PB7);
		_delay_ms(50);
		//--
		PORTB |= _BV(PB6);
		_delay_ms(50);
}

int heart_brightness()
{
	PORTB=0x00;
	DDRB=0xFF;
 
	PORTC=0x00;
	DDRC=0xFF;

	PORTD=0x00;
	DDRD=0xFF;

	while(1)
	{
		int n,m,k,v;
		k=1;
		m=0;
		v=255;
 		
		while(1)
		{
			PORTB=0xFF;
			PORTC=0xFF;
			PORTD=0xFF;
 
			for(n=0; n<=v; n++)
			{
				if(n==k)
				{
					PORTD &= ~_BV(PD4);
					PORTB &= ~_BV(PB6);
					PORTD &= ~_BV(PD3);
					PORTB &= ~_BV(PB7);
					PORTD &= ~_BV(PD2);
					PORTD &= ~_BV(PD5);
					PORTD &= ~_BV(PD1);
					PORTD &= ~_BV(PD6);
					PORTD &= ~_BV(PD0);
					PORTD &= ~_BV(PD7);
					PORTC &= ~_BV(PC5);
					PORTB &= ~_BV(PB0);
					PORTC &= ~_BV(PC4);
					PORTB &= ~_BV(PB1);
					PORTC &= ~_BV(PC3);
					PORTB &= ~_BV(PB2);
					PORTC &= ~_BV(PC2);
					PORTB &= ~_BV(PB3);
					PORTC &= ~_BV(PC1);
					PORTB &= ~_BV(PB4);
					PORTC &= ~_BV(PC0);
					PORTB &= ~_BV(PB5);
				}
			}
			m--;
			if(m<=5) {k++; m=0;}
			if(k==v) k=0;
 		};
	};
}

int main(void)
{	
	//устанавливаем все порты на выход
	DDRB = 0xFF;
	DDRC = 0xFF;
	DDRD = 0xFF;
	
	while(1)
	{
		_delay_ms(1500);		
		heart_one();
			full_leds_off();
		heart_two();
			full_leds_off();
		heart_three();
			full_leds_off();
		heart_four();
			full_leds_off();
		heart_five();
			full_leds_off();
		heart_six();
			full_leds_off();
		heart_seven();
			full_leds_off();
		heart_eight();
			full_leds_off();
		heart_brightness();
	}
}
